/*

        Copyright 2007-2014 CNR-ISTI, http://isti.cnr.it
        Institute of Information Science and Technologies
        of the Italian National Research Council

        See the NOTICE file distributed with this work for additional
        information regarding copyright ownership

        Licensed under the Apache License, Version 2.0 (the "License");
        you may not use this file except in compliance with the License.
        You may obtain a copy of the License at

          http://www.apache.org/licenses/LICENSE-2.0

        Unless required by applicable law or agreed to in writing, software
        distributed under the License is distributed on an "AS IS" BASIS,
        WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
        See the License for the specific language governing permissions and
        limitations under the License.
 */
package org.universaal.tools.packaging.tool.parts;

import java.io.Serializable;
import java.net.URI;

/**
 * 
 * @author <a href="mailto:manlio.bacco@isti.cnr.it">Manlio Bacco</a>
 * @author <a href="mailto:stefano.lenzi@isti.cnr.it">Stefano Lenzi</a>
 * @version $LastChangedRevision$ ( $LastChangedDate$ )
 */
public class SLA implements Serializable{

	private String name;		
	private URI link;

	public SLA(){

		name = Application.defaultString;
		link = URI.create(Application.defaultURL);
	}

	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public URI getLink() {
		return link;
	}
	public void setLink(URI link) {
		this.link = link;
	}

	public String getXML(){

		String link_string = "";
		if(link.getScheme() != null && link.getScheme().equalsIgnoreCase("file")){
			String[] splitted = link.toASCIIString().split("/"); 
			link_string = Application.file_prefix+splitted[splitted.length-1];
		}
		else
			link_string = link.toASCIIString();

		return "<sla><name>"+name+"</name><link>"+link_string+"</link></sla>";
	}
}